apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: scan-image-clair
  namespace: {{ buildns }}
spec:
  params:
  - name: dstimage
    description: Image to Scan
    type: string
  steps:
  - args:
    - -c
    - |
{% if do_debugs %}
        set -x;
{% endif %}
        echo "==== Scanning $(params.dstimage) ===="
        if ! CLAIR_ADDR="{{ clair_api_address | default('DEPLOY CLAIR FIRST') }}" \
                CLAIR_TIMEOUT=10 DOCKER_INSECURE=true DOCKER_TIMEOUT=3 \
{% if k8s_flavor == 'openshift' %}
                DOCKER_USER={{ pipeline_sa }} \
                DOCKER_PASSWORD="$(cat /var/run/secrets/kubernetes.io/serviceaccount/token)" \
                JSON_OUTPUT=true REGISTRY_INSECURE=false DOCKER_INSECURE=false \
{% elif docker_registry_token | default(False) %}
                DOCKER_TOKEN={{ docker_registry_token }} \
                JSON_OUTPUT=true REGISTRY_INSECURE=false DOCKER_INSECURE=true \
{% elif docker_registry_is_http | default(False) %}
                JSON_OUTPUT=true REGISTRY_INSECURE=false DOCKER_INSECURE=true \
{% else %}
                JSON_OUTPUT=true REGISTRY_INSECURE=true DOCKER_INSECURE=true \
{% endif %}
                klar "$(params.dstimage)" >/tmp/scan-output; then
            echo "==== Returned $? ===="
        fi
        if ! test -s /tmp/scan-output; then
            echo "==== Failed scanning image ===="
            rm -f /tmp/scan-output
            exit 1
        fi
        echo "==== Done scanning - parsing output ===="
        for level in Critical Defcon1 High Low Medium Negligible Unknown
        do
            echo "==== Listing criticity '\$level' ===="
            cat /tmp/scan-output | jq ".Vulnerabilities.$level"
            count=$(cat /tmp/scan-output | jq ".Vulnerabilities.$level" | sed 's|^null\$|[]|' | jq '.[].Name ' | awk 'END{print NR}')
            eval count$level=$count
        done
        rm -f /tmp/scan-output
        if ! test "$countCritical" = 0 -a "$countDefcon1" = 0; then
            score=CRITICAL
        elif ! test "$countHigh" = 0; then
            score=WARNING
        else
            score=OK
        fi
        echo =============================================
        echo =============================================
        echo =============================================
        echo "[$score] $(params.dstimage)"
        echo ""
        echo " * critical: $countCritical"
        echo " * defcon1: $countDefcon1"
        echo " * high: $countHigh"
        echo " * low: $countLow"
        echo " * medium: $countMedium"
        echo " * negligible: $countNegligible"
        echo " * unknown: $countUnknown"
    command:
    - /bin/sh
    image: {{ (opsimages | json_query("[?name=='jkagklar'].image"))[0] }}
    name: scan-image
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_klar_cpu_limit }}"
        memory: {{ tekton_klar_memory_limit }}
      requests:
        cpu: "{{ tekton_klar_cpu_request }}"
        memory: {{ tekton_klar_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
{% if 0 == 1 %}
      runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      privileged: true
{% endif %}
{% endif %}
